VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Socket"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Const PB_COMMAND            As String = "Command"
Private Const PB_DATA               As String = "Data"
Private Const CMD_DATA_SIZE         As String = "DataSize"
Private Const CMD_CUSTOM            As String = "Custom"

Private Type mtypHeaderProps
    DataLength      As Long
    ExternalData    As Boolean
End Type

Private Type mtypHeaderData
    Data        As String * 4
End Type

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal ByteLen As Long)
Private Declare Function SafeArrayGetDim Lib "oleaut32.dll" (ByRef saArray() As Any) As Long
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Public Event Listening()
Public Event ConnectionRequest(ByVal requestID As Long, ByRef Cancel As Boolean)
Public Event Connected()
Public Event Disconnected()
Public Event DataArrivalStarted(ByVal TotalBytes As Long)
Public Event DataArriving(ByVal ByteCount As Long)
Public Event DataArrived(ByRef Data As Variant)
Public Event SendStarted(ByVal TotalBytes As Long)
Public Event SendProgress(ByVal bytesSent As Long)
Public Event SendCompleted()
Public Event Error(ByVal Number As Long, ByVal Source As String, ByVal Description As String)

Private WithEvents mobjSocket       As clsSocket
Attribute mobjSocket.VB_VarHelpID = -1

Private mlngWoof        As Long

Private mblnHeader      As Boolean
Private mlngDataSize    As Long

Private Sub Class_Initialize()
    Set mobjSocket = New clsSocket
End Sub

Private Sub Class_Terminate()
    Disconnect
    Set mobjSocket = Nothing
End Sub

Public Property Get LocalHostName() As String
    LocalHostName = mobjSocket.LocalHostName
End Property

Public Property Get LocalIP() As String
    LocalIP = mobjSocket.LocalIP
End Property

Public Property Get LocalPort() As Long
    LocalPort = mobjSocket.LocalPort
End Property

Public Property Get RemoteIP() As String
    RemoteIP = mobjSocket.RemoteHostIP
End Property

Public Property Get RemotePort() As Long
    RemotePort = mobjSocket.RemotePort
End Property

Public Property Get IsConnected() As Boolean
    IsConnected = (mobjSocket.State = sckConnected)
End Property

Public Property Get SocketHandle() As Long
    SocketHandle = mobjSocket.SocketHandle
End Property

Public Sub Connect(ByVal LocalPort As Long, ByVal RemoteHost As String, ByVal RemotePort As Long)
Dim strHost As String
    strHost = Trim$(RemoteHost)
    If InStr(1, RemoteHost, ".") = 0 And Len(RemoteHost) > 0 Then
        strHost = GetIPAddress(strHost)
    End If
    ValidateHost strHost
    mobjSocket.LocalPort = LocalPort
    mobjSocket.Connect strHost, RemotePort
End Sub

Private Sub ValidateHost(ByVal pstrHost As String)
Dim blnError    As Boolean
Dim lngIndex    As Long
Dim strIP()     As String
On Error GoTo Errhandler
    strIP = Split(pstrHost, ".")
    If Not UBound(strIP) = 3 Then
        blnError = True
    Else
        For lngIndex = 0 To 3
            If CLng(strIP(lngIndex)) < 0 Or CLng(strIP(lngIndex)) > 255 Then
                blnError = True
                Exit For
            End If
        Next lngIndex
    End If
    If blnError Then
        Err.Raise 0
    End If
    Exit Sub
Errhandler:
    Err.Raise vbObjectError, , "Invalid network IP address."
End Sub

Public Sub Listen(ByVal LocalPort As Long)
    With mobjSocket
        CloseConnection
        .LocalPort = LocalPort
        .Listen
    End With
    RaiseEvent Listening
End Sub

Public Sub Disconnect()
    CloseConnection
End Sub

Private Sub CloseConnection()
    With mobjSocket
        If Not (.State = sckClosed) Then
            .CloseSocket
        End If
    End With
End Sub

Public Sub SendData(ByVal Data As Variant)
Dim bytUID()    As Byte
Dim bytData()   As Byte
Dim objPB       As PropertyBag
Dim lngStart    As Long
    bytData = CreateSendData(CMD_CUSTOM, Data)
    RaiseEvent SendStarted(UBound(bytData) + 1)
    mobjSocket.SendData bytData
    Sleep 50
    Erase bytData
End Sub

Private Function CreateSendData(ByVal pstrCommand As String, ByVal Data As Variant) As Byte()
Dim bytHeader()     As Byte
Dim bytData()       As Byte
Dim bytDataOut()    As Byte
Dim objPB           As PropertyBag
Dim lngDataLen      As Long
Dim udtProps        As mtypHeaderProps
Dim udtData         As mtypHeaderData
    Set objPB = New PropertyBag
    objPB.WriteProperty PB_COMMAND, pstrCommand
    objPB.WriteProperty PB_DATA, Data
    bytData = objPB.Contents
    Set objPB = Nothing
    lngDataLen = UBound(bytData) + 1
    ReDim bytDataOut(LenB(udtProps) + UBound(bytData)) As Byte
    udtProps.DataLength = lngDataLen
    udtProps.ExternalData = (pstrCommand = CMD_CUSTOM)
    LSet udtData = udtProps
    bytHeader = udtData.Data
    CopyMemory bytDataOut(0), bytHeader(0), UBound(bytHeader) + 1
    CopyMemory bytDataOut(UBound(bytHeader) + 1), bytData(0), lngDataLen
    CreateSendData = bytDataOut
End Function

Private Function InByt(ByRef pbytSearch() As Byte, ByRef pbytFind() As Byte, ByVal plngStart As Long) As Long
Dim lngSearch           As Long
Dim lngFind             As Long
    InByt = -1
    For lngSearch = plngStart To UBound(pbytSearch) - UBound(pbytFind) + 1
        For lngFind = 0 To UBound(pbytFind)
            If pbytSearch(lngSearch + lngFind) = pbytFind(lngFind) Then
                If lngFind = UBound(pbytFind) Then
                    InByt = lngSearch
                    Exit Function
                End If
            Else
                Exit For
            End If
        Next lngFind
    Next lngSearch
End Function

Private Sub ExtractData(ByRef pbytData() As Byte)
Dim strCommand  As String
Dim varData     As Variant
Dim objPB       As PropertyBag
    Set objPB = New PropertyBag
    objPB.Contents = pbytData
    strCommand = objPB.ReadProperty(PB_COMMAND)
    varData = objPB.ReadProperty(PB_DATA)
    Set objPB = Nothing
    Select Case strCommand
        Case CMD_DATA_SIZE
            Debug.Print "DATA_SIZE"
            mlngDataSize = CLng(varData)
            Beep
        Case CMD_CUSTOM
            mlngDataSize = 0
            RaiseEvent DataArrived(varData)
    End Select
    mlngWoof = mlngWoof + 1
    Set objPB = Nothing
End Sub

Private Sub mobjSocket_OnClose()
    CloseConnection
    RaiseEvent Disconnected
End Sub

Private Sub mobjSocket_OnConnect()
    RaiseEvent Connected
End Sub

Private Sub mobjSocket_OnConnectionRequest(ByVal requestID As Long)
    Dim blnCancel   As Boolean
    RaiseEvent ConnectionRequest(requestID, blnCancel)
    If Not blnCancel Then
        CloseConnection
        mobjSocket.Accept requestID
        RaiseEvent Connected
    End If
End Sub

Private Sub mobjSocket_OnDataArrival(ByVal bytesTotal As Long)
Static bytAllData()     As Byte
Dim bytNew()            As Byte
Dim bytNext()           As Byte
Dim bytLeftOver()       As Byte
Dim blnNew              As Boolean
Dim blnCheckData        As Boolean
Dim lngIndex            As Long
Dim bytHeader()         As Byte
Dim udtProps            As mtypHeaderProps
Dim udtData             As mtypHeaderData
    mobjSocket.GetData bytNew, vbByte + vbArray
    blnNew = (SafeArrayGetDim(bytAllData) = 0)
    If blnNew Then
        bytAllData = bytNew
    Else
        ReDim Preserve bytAllData(UBound(bytAllData) + UBound(bytNew) + 1) As Byte
        CopyMemory bytAllData(UBound(bytAllData) - bytesTotal + 1), bytNew(0), UBound(bytNew) + 1
    End If
    Erase bytNew
    blnCheckData = True
    Do While blnCheckData
        If mlngDataSize = 0 Then
            If LenB(udtData) <= UBound(bytAllData) + 1 Then
                ReDim bytHeader(LenB(udtProps) - 1) As Byte
                CopyMemory bytHeader(0), bytAllData(0), LenB(udtProps) - 1
                udtData.Data = bytHeader
                LSet udtProps = udtData
                mlngDataSize = udtProps.DataLength
                ReDim bytHeader(UBound(bytAllData) - LenB(udtProps)) As Byte
                CopyMemory bytHeader(0), bytAllData(LenB(udtProps)), UBound(bytAllData) - LenB(udtProps) + 1
                bytAllData = bytHeader
                Erase bytHeader
                RaiseEvent DataArrivalStarted(mlngDataSize)
            End If
        Else
            If mlngDataSize <= UBound(bytAllData) Then
                RaiseEvent DataArriving(mlngDataSize)
            Else
                RaiseEvent DataArriving(UBound(bytAllData) + 1)
            End If
        End If
      
        If UBound(bytAllData) + 1 >= mlngDataSize Then
            lngIndex = mlngDataSize - 1
        Else
            lngIndex = -1
        End If
        If lngIndex > -1 Then
            ReDim bytNew(lngIndex) As Byte
            CopyMemory bytNew(0), bytAllData(0), lngIndex + 1
            If UBound(bytAllData) = lngIndex Then
                Erase bytAllData
                blnCheckData = False
            Else
                ReDim bytLeftOver(UBound(bytAllData) - lngIndex - 1) As Byte
                CopyMemory bytLeftOver(0), bytAllData(lngIndex + 1), UBound(bytLeftOver) + 1
                bytAllData = bytLeftOver
                Erase bytLeftOver
                blnCheckData = True
                mlngDataSize = 0
            End If
            ExtractData bytNew
        Else
            blnCheckData = False
        End If
    Loop
End Sub

Private Sub mobjSocket_OnError(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    RaiseEvent Error(Number, Source, Description)
End Sub

Private Sub mobjSocket_OnSendComplete()
    If Not mblnHeader Then
        RaiseEvent SendCompleted
    End If
End Sub

Private Sub mobjSocket_OnSendProgress(ByVal bytesSent As Long, ByVal bytesRemaining As Long)
    If Not mblnHeader Then
        RaiseEvent SendProgress(bytesSent)
    End If
End Sub
